/* wydawca - automatic release submission daemon
   Copyright (C) 2009 Sergey Poznyakoff

   Wydawca is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by the
   Free Software Foundation; either version 3 of the License, or (at your
   option) any later version.

   Wydawca is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License along
   with wydawca. If not, see <http://www.gnu.org/licenses/>. */

#include "wydawca.h"

int
null_move_file (struct file_triplet *trp, struct directory_pair *dpair,
		enum file_type file_id, const char *reldir)
{
  if (debug_level)
    logmsg (LOG_DEBUG, "%s: installing file `%s/%s'",
	    dpair->url, reldir, trp->file[file_id].name);
  return 0;
}

int
null_archive_file (struct file_triplet *trp, struct directory_pair *dpair,
		   const char *file_name, const char *reldir)
{
  if (debug_level)
    logmsg (LOG_DEBUG, "%s: archiving `%s'",  dpair->url, file_name);
  return 0;
}

int
null_symlink_file (struct file_triplet *trp, struct directory_pair *dpair,
		   const char *reldir,
		   const char *wanted_src, const char *wanted_dst)
{
  if (debug_level)
    logmsg (LOG_DEBUG, "%s: symlinking `%s' to `%s'",
	    dpair->url, wanted_src, wanted_dst);
  return 0;
}

int
null_rmsymlink_file (struct file_triplet *trp, struct directory_pair *dpair,
		     const char *reldir, const char *file_name)
{
  if (debug_level)
    logmsg (LOG_DEBUG, "%s: removing symlink `%s/%s'",
	    dpair->url, reldir, file_name);
  return 0;
}

